CMDB Meta API
The CMDB Meta API provides endpoints to obtain meta data on a Configuration Management Database (CMDB) class.
This API requires that the user have the ITIL role.
CMDB Meta - GET /now/cmdb/meta/{classname}
Returns the meta data for the specified CMDB class.
URL format
Versioned URL: /api/now/{api_version}/cmdb/meta/{className}
Default URL: /api/now/cmdb/meta/{className}
Supported request parameters
| Name | Description |
|---|---|
| api_version | Optional. Version of the endpoint to access. For example, v1 or v2. Only specify this value to use an endpoint version other than the
latest.
Data type: String |
| className | CMDB class name.
This is the name of the table that contains the desired CI records, such as
cmdb_ci_linux_server or cmdb_ci_apache_web_server. Data type: String |
| Name | Description |
|---|---|
| None |
| Name | Description |
|---|---|
| None |
Headers
The following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see Supported REST API headers.
| Header | Description |
|---|---|
| Accept | Data format of the response body. Supported types: application/json or application/xml.
Default: application/json |
| Header | Description |
|---|---|
| None |
Status codes
The following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see REST API HTTP response codes.
| Status code | Description |
|---|---|
| 200 | Successful. The request was successfully processed. |
| 401 | Unauthorized. The user credentials are incorrect or have not been passed. |
| 404 | Not found. The requested item wasn't found. |
| 500 | Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error. |
Response body parameters (JSON or XML)
| Element | Description |
|---|---|
| attributes | Available fields in the specified class table. Data type: Array |
| children | List of classes extended from the specified class. Data type: Array |
| icon | Class icon sys_id. Data type: String |
| icon_url | Class icon URL. Data type: String |
| identification_rules | Attributes associated with the configuration item identification rules for the
specified class. Data type: Object |
| is_extendable | Flag that indicates whether the class can be extended to create other
classes. Possible values:
Data type: Boolean |
| label | Specified class display name. Data type: String |
| name | Table/class name. Data type: String |
| parent | Parent class. Data type: String |
| relationship_rules | Relationships between the specifed class and other classes in the CMDB. Data type: Array |
Sample cURL request
curl "https://instance.servicenow/api/now/cmdb/meta/cmdb_ci_computer" \
--request GET \
--header "Accept:application/json" \
--user 'username':'password'
{
"result": {
"icon_url": "images/app.ngbsm/computer.svg",
"is_extendable": true,
"parent": "cmdb_ci_hardware",
"children": [
"cmdb_ci_ucs_blade",
"cmdb_ci_pc_hardware",
"cmdb_ci_ucs_rack_unit",
"cmdb_ci_mainframe_hardware",
"cmdb_ci_server",
"cmdb_ci_storage_switch"
],
"name": "cmdb_ci_computer",
"icon": "c6442dd69fb00200eb3919eb552e7012",
"attributes": [
{
"is_inherited": "false",
"is_mandatory": "false",
"is_read_only": "false",
"default_value": null,
"label": "OS Address Width (bits)",
"type": "integer",
"element": "os_address_width",
"max_length": "40",
"is_display": "false"
},
{
"is_inherited": "true",
"is_mandatory": "false",
"is_read_only": "true",
"default_value": "false",
"label": "Skip sync",
"type": "boolean",
"element": "skip_sync",
"max_length": "40",
"is_display": "false"
},
{
"is_inherited": "true",
"is_mandatory": "false",
"is_read_only": "false",
"default_value": null,
"label": "DNS Domain",
"type": "string",
"element": "dns_domain",
"max_length": "255",
"is_display": "false"
},
{
"is_inherited": "true",
"is_mandatory": "false",
"is_read_only": "false",
"default_value": null,
"label": "Purchased",
"type": "glide_date",
"element": "purchase_date",
"max_length": "40",
"is_display": "false"
},
{
"is_inherited": "true",
"is_mandatory": "false",
"is_read_only": "false",
"default_value": null,
"label": "Lease contract",
"type": "string",
"element": "lease_id",
"max_length": "40",
"is_display": "false"
}
],
"relationship_rules": [
{
"parent": "cmdb_ci_computer",
"relation_type": "cb5592603751200032ff8c00dfbe5d17",
"child": "dscy_route_next_hop"
},
{
"parent": "cmdb_ci_computer",
"relation_type": "cb5592603751200032ff8c00dfbe5d17",
"child": "dscy_router_interface"
},
{
"parent": "cmdb_ci_computer",
"relation_type": "cb5592603751200032ff8c00dfbe5d17",
"child": "dscy_route_interface"
},
{
"parent": "cmdb_ci_computer",
"relation_type": "55c95bf6c0a8010e0118ec7056ebc54d",
"child": "cmdb_ci_storage_pool"
},
{
"parent": "cmdb_ci_computer",
"relation_type": "55c95bf6c0a8010e0118ec7056ebc54d",
"child": "cmdb_ci_disk_partition"
},
{
"parent": "cmdb_ci_computer",
"relation_type": "55c95bf6c0a8010e0118ec7056ebc54d",
"child": "cmdb_ci_storage_volume"
},
{
"parent": "cmdb_ci_computer",
"relation_type": "55c95bf6c0a8010e0118ec7056ebc54d",
"child": "cmdb_ci_storage_device"
}
],
"label": "Computer",
"identification_rules": {
"related_rules": [
{
"condition": "",
"exact_count_match": false,
"referenced_field": "installed_on",
"active": true,
"attributes": "name",
"allow_fallback": false,
"table": "cmdb_print_queue_instance",
"order": 100,
"allow_null_attribute": false
}
],
"applies_to": "cmdb_ci_hardware",
"identifiers": [
{
"condition": "valid=true^absent=false^EQ",
"exact_count_match": true,
"referenced_field": "cmdb_ci",
"active": true,
"attributes": "serial_number,serial_number_type",
"allow_fallback": false,
"table": "cmdb_serial_number",
"order": 100,
"allow_null_attribute": false
},
{
"condition": null,
"exact_count_match": false,
"referenced_field": null,
"active": true,
"attributes": "serial_number",
"allow_fallback": false,
"table": null,
"order": 200,
"allow_null_attribute": false
},
{
"condition": null,
"exact_count_match": false,
"referenced_field": null,
"active": true,
"attributes": "name",
"allow_fallback": false,
"table": null,
"order": 300,
"allow_null_attribute": false
},
{
"condition": "install_status!=100^EQ",
"exact_count_match": true,
"referenced_field": "cmdb_ci",
"active": true,
"attributes": "ip_address,mac_address",
"allow_fallback": false,
"table": "cmdb_ci_network_adapter",
"order": 400,
"allow_null_attribute": false
}
],
"name": "Hardware Rule",
"description": "Identifier for hardware.",
"active": true,
"is_independent": true
}
}
}